<?php

    require("php/basicteamstatslayout.php");

    Class TeamstatsLayout extends BasicTeamstatsLayout {
    
	# Dimensions of the counter
	var $min_width  = 280;
	var $height     =  70;
	var $tx         =   4;
	var $ty         =   1;
	
	
	var $im, $white, $red, $gray, $lightgray, $lightblue, $text_color, $border_color, $background_color, $label_color, $tcol, $bcol, $lcol;
	
	function initColors() {
	    global $tcolor, $tc, $bcolor, $bc, $lc;
	    
	    if(isset($tcolor)) {
		$tc = $tcolor;
	    }
	    
	    if(isset($bcolor)) {
		$bc = $bcolor;
	    }
	    
	    $xml = $this->getProperties();
	    
	    if(!is_array($this->tcol)) {
		if (!isset($tc)) {
		    $found = $xml->search_attributes("properties:property","1:?","name","textcolor");
		    $tc = $xml->get_attribute("properties:property:defaultvalue", "1:" . $found[0] . ":1", "value");
		}
		$this->tcol = explode(",",$tc);
	    }
	    
	    if(!is_array($this->bcol)) {
		if (!isset($bc)) {
		    $found = $xml->search_attributes("properties:property","1:?","name","bordercolor");
		    $bc = $xml->get_attribute("properties:property:defaultvalue", "1:" . $found[0] . ":1", "value");
		}
		$this->bcol = explode(",",$bc);
	    }
	    
	    if(!is_array($this->lcol)) {
		if (!isset($lc)) {
		    $found = $xml->search_attributes("properties:property","1:?","name","labelcolor");
		    $lc = $xml->get_attribute("properties:property:defaultvalue", "1:" . $found[0] . ":1", "value");
		}
		$this->lcol = explode(",",$lc);
	    }
	}
	
	
	function init() {
	    
	    # initialize image pointer
	    $this->im = @imagecreate($this->width, $this->height);

	    # Farben definieren
	    $this->white = ImageColorAllocate($this->im, 255,255,255);
	    ImageColorTransparent($this->im, $this->white); # wei = transparent
	    
	    $this->red = ImageColorAllocate($this->im, 255,0,0);
	    $this->gray = ImageColorAllocate($this->im, 128,128,128);
	    $this->lightgray = ImageColorAllocate($this->im, 224,224,224);
	    $this->lightblue = ImageColorAllocate($this->im, 128,128,255);
	    
	    
	    $this->initColors();
	    $this->text_color = ImageColorAllocate($this->im, $this->tcol[0], $this->tcol[1], $this->tcol[2]);
	    $this->border_color = ImageColorAllocate($this->im, $this->bcol[0], $this->bcol[1], $this->bcol[2]);
	    $this->label_color = ImageColorAllocate($this->im, $this->lcol[0], $this->lcol[1], $this->lcol[2]);
	    
	    $this->background_color = $this->white;
	}
	
	
	    
	/**
	 * returns the properties of this layout as a xml object
	 *
	 */
	function getProperties()
	{
	  if(!isset($this->xml)) {
	    
	    $myXML = BasicTeamstatsLayout::getProperties();
	    
	    $i = 0;
	    
	    # Text color
	    $i++;
	    $myXML->create_tag("properties","1","property");
	    $myXML->set_attribute("properties:property", "1:$i", "name", "textcolor");
	    $myXML->set_attribute("properties:property", "1:$i", "alias", "tc");
	    $myXML->create_tag("properties:property","1:$i","type");
	    $myXML->set_attribute("properties:property:type","1:$i:1", "value", "rgb") ;
	    $myXML->create_tag("properties:property","1:$i","defaultvalue");
	    $myXML->set_attribute("properties:property:defaultvalue", "1:$i:1", "value", "0,0,0") ; // Standardwert
	    
	    # Border color
	    $i++;
	    $myXML->create_tag("properties","1","property");
	    $myXML->set_attribute("properties:property", "1:$i", "name", "bordercolor");
	    $myXML->set_attribute("properties:property", "1:$i", "alias", "bc");
	    $myXML->create_tag("properties:property","1:$i","type");
	    $myXML->set_attribute("properties:property:type","1:$i:1", "value", "rgb") ;
	    $myXML->create_tag("properties:property","1:$i","defaultvalue");
	    $myXML->set_attribute("properties:property:defaultvalue", "1:$i:1", "value", "0,0,0") ; // Standardwert
	    
#	    # Background color
#	    $i++;
#	    $myXML->create_tag("properties","1","property");
#	    $myXML->set_attribute("properties:property", "1:$i", "name", "bgcolor");
#	    $myXML->set_attribute("properties:property", "1:$i", "alias", "bg");
#	    $myXML->create_tag("properties:property","1:$i","type");
#	    $myXML->set_attribute("properties:property:type","1:$i:1", "value", "rgb") ;
#	    $myXML->set_attribute("properties:property:type","1:$i:1", "transparent", "true") ;
#	    $myXML->create_tag("properties:property","1:$i","defaultvalue");
#	    $myXML->set_attribute("properties:property:defaultvalue", "1:$i:1", "value", "255,255,255") ; // Standardwert
	    
	    
	    # Label color
	    $i++;
	    $myXML->create_tag("properties","1","property");
	    $myXML->set_attribute("properties:property", "1:$i", "name", "labelcolor");
	    $myXML->set_attribute("properties:property", "1:$i", "alias", "lc");
	    $myXML->create_tag("properties:property","1:$i","type");
	    $myXML->set_attribute("properties:property:type","1:$i:1", "value", "rgb") ;
	    $myXML->create_tag("properties:property","1:$i","defaultvalue");
	    $myXML->set_attribute("properties:property:defaultvalue", "1:$i:1", "value", "128,128,255") ; // Standardwert
	    
	    # Language
	    $i++;
	    $myXML->create_tag("properties","1","property");
	    $myXML->set_attribute("properties:property", "1:$i", "name", "language");
	    $myXML->set_attribute("properties:property", "1:$i", "alias", "lng");
	    $myXML->create_tag("properties:property","1:$i","type");
	    $myXML->set_attribute("properties:property:type","1:$i:1", "value", "key_value") ;
	    
	    $keys   = "";
	    $values = "";
	    $current_locale = setlocale(LC_TIME, "0");
	    
	    $lang = explode(",", getenv("HTTP_ACCEPT_LANGUAGE"));
	    $lang_count = count($lang);
	    $lang_prio  = $lang_count + 1;
	    
	    $d = dir("language");
	    while($entry=$d->read())
	    {
		if(is_file("language/" . $entry))
		{
		    require("language/" . $entry);
		    $value = substr($entry, 0, strpos($entry, ".inc"));
		    $values .= ";" . $value;
		    $keys   .= ";" . $language_native . " / " . $language_international;
		    
		    $found = false;
		    
		    for($n = 0; ($n < $lang_count) && (!$found) && ($n < $lang_prio); $n++) {
			if(strpos($lang[$n], $value) !== false) {
			    $default = $value;
			    $lang_prio = $n;
			    $found = true;
			}
		    }
		}
	    }
	    
	    if(strlen($default) == 0) {
		$default = $GLOBALS["default_language"];
	    }
	    
	    setlocale(LC_TIME, $current_locale);
	    
	    $myXML->create_tag("properties:property","1:$i","defaultvalue");
	    $myXML->set_attribute("properties:property:defaultvalue", "1:$i:1", "value", $default) ; // Standardwert
	    
	    $myXML->create_tag("properties:property","1:$i","autodetect");
	    $myXML->set_attribute("properties:property:autodetect", "1:$i:1", "value", "true");
	    
	    $myXML->create_tag("properties:property","1:$i","keys");
	    $myXML->create_tag("properties:property","1:$i","values");
	    $myXML->set_attribute("properties:property:keys", "1:$i:1", "value", substr($keys, 1)) ; // Werte
	    $myXML->set_attribute("properties:property:values", "1:$i:1", "value", substr($values, 1)) ; // Schluessel
	    
	    $values = "";
	    $keys = "";
	    
	    # Image format
	    $i++;
	    $myXML->create_tag("properties","1","property");
	    $myXML->set_attribute("properties:property", "1:$i", "name", "graficsformat");
	    $myXML->set_attribute("properties:property", "1:$i", "alias", "gf");
	    $myXML->create_tag("properties:property","1:$i","type");
	    $myXML->set_attribute("properties:property:type","1:$i:1", "value", "key_value") ;
	    $myXML->create_tag("properties:property","1:$i","defaultvalue");
	    $myXML->set_attribute("properties:property:defaultvalue", "1:$i:1", "value", "png") ; // Standardwert

	    $knowntypes = imagetypes();
	    
	    if($knowntypes & IMG_PNG)
	    {
		    $values .= ";png";
		    $keys   .= ";Portable Network Grafics Format (PNG)";
		    if(strlen($default) == 0)
		    {
			$default = "png";
		    }
	    }
	    
	    if($knowntypes & IMG_JPG)
	    {
		    $values .= ";jpg;jpg75;jpg50;jpg25";
		    $keys   .= ";Jpeg Format (Quality: 100%);Jpeg Format (Quality: 75%);Jpeg Format (Quality: 50%);Jpeg Format (Quality: 25%)";
		    if(strlen($default) == 0)
		    {
			$default = "jpg";
		    }
	    }
	    
	    if($knowntypes & IMG_GIF)
	    {
		    $values .= ";gif";
		    $keys   .= ";Grafics Interchange Format (GIF)";
		    if(strlen($default) == 0)
		    {
			$default = "gif";
		    }
	    }
	    
	    if($knowntypes & IMG_WBMP)
	    {
		    $values .= ";wbmp";
		    $keys   .= ";WAP Bitmap Format (WBMP)";
		    if(strlen($default) == 0)
		    {
			$default = "wbmp";
		    }
	    }
		    
	    $myXML->create_tag("properties:property","1:$i","defaultvalue");
	    $myXML->set_attribute("properties:property:defaultvalue", "1:$i:1", "value", $default) ; // Standardwert
	    
	    $myXML->create_tag("properties:property","1:$i","keys");
	    $myXML->create_tag("properties:property","1:$i","values");
	    $myXML->set_attribute("properties:property:keys", "1:$i:1", "value", substr($keys, 1)) ; // Werte
	    $myXML->set_attribute("properties:property:values", "1:$i:1", "value", substr($values, 1)) ; // Schluessel
	    
	    
	    
	  
	    $this->xml = $myXML;
	  
	  } else {
	    $myXML = $this->xml;
	  }
	    
	    return $myXML;
	}
	
	
	function printBox()
	{
	    $title   = $GLOBALS["team_seitlicher_string"];
	    $sponsor = $GLOBALS["sponsored_by"];
	    $version = $this->declareVersion_;
	    imagerectangle($this->im, 0, 0, $this->width -16, $this->height -1, $this->border_color );
	    imagerectangle($this->im, $this->width -14, 0,$this->width -1, $this->height -1, $this->border_color );
	    imagestringup ($this->im, 3, $this->width -14, $this->height -3,$title, $this->label_color);
	    imagestring($this->im, 1, ($this->width -imagefontwidth(1)*strlen($version))-18,($this->height  - imagefontheight(1) - 1), $version, $this->lightgray);
	    imagestring($this->im, 1, $this->tx, ($this->height  - imagefontheight(1) - 1), $sponsor, $this->label_color);
	}
	
    
        function showError($headline, $msg, $status="")
	{
	    $this->width = $this->min_width;
	    $this->init();
	    $this->printBox();
	
	    $charsPerLine = ($this->width -17)/imagefontwidth(2);
	
    	    # headline
	    imagestring($this->im, 3, $this->tx +1, 1, $headline, $this->gray );
	    imagestring($this->im, 3, $this->tx ,   0, $headline, $this->red );
	
	    #message
	    $msgwords = strtok($msg, " ");
	    $line = 1;
	    $text = "";
	    while($msgwords) {
		if((strlen($text) + strlen($msgwords)) > $charsPerLine) {
		    imagestring($this->im, 2, $this->tx , ($line * 12), $text, $this->text_color );
		    $line++;
		    $text = "";
		}
		$text .= $msgwords . " ";
		$msgwords = strtok(" ");
	    }
	    if(strlen(text) > 0) {
		imagestring($this->im, 2, $this->tx , ($line * 12), $text, $this->text_color );
	    }
	    imagestring($this->im, 2, $this->tx ,  48, $status, $this->text_color );
	
	    $this->error  = true;
	
	    $this->sendGrafic();
	}
	
	
	function sendGrafic()
	{
	    global $gf;
	    
	    $xml = $this->getProperties();
	    
	    if (!isset($gf)) {
		$found = $xml->search_attributes("properties:property","1:?","name","graficsformat");
		$gf = $xml->get_attribute("properties:property:defaultvalue", "1:" . $found[0] . ":1", "value");
	    }
	    
	    # Grafik ausgeben
	    if(substr($gf, 0, 3) == "jpg") {
		header('Content-type: image/jpeg');
		if($gf == "jpg")
		    imagejpeg($this->im);
		else if($gf == "jpg75")
		    imagejpeg($this->im, '', 75);
		else if($gf == "jpg50")
		    imagejpeg($this->im, '', 50);
		else if($gf == "jpg25")
		    imagejpeg($this->im, '', 25);
	    } else if($gf == "gif") {
		header('Content-type: image/gif');
		imagegif($this->im);
	    } else if($gf == "wbmp") {
		header('Content-type: image/vnd.wap.wbmp');
		imagewbmp($this->im);
	    } else {
		header('Content-type: image/png');
		imagepng($this->im);
	    }
	    
	}
	
	function showStats() {
	    
	
	
	    $this->width = $this->min_width;
	    
	    $stats = $this->stats;
	    $team = $stats->getTeam();
	    
	    
	    setlocale(LC_ALL, $GLOBALS["language_locale"]);
	    $locale_info = localeconv();
	    
	    
	    ## Daten formatieren und berechnen
	    $cputimef = timetostr($stats->getCputime(), 12);
	    
	    if($stats->getWUCount() != 0) {
		$averagef = timetostr($stats->getAveragetime(), 14);
	    } else {
		$averagef = timetostr(0, 14);
	    }

	    $name = $team->getName();
	    

	    $diff14days = $stats->getDiff14days();
	    if($diff14days["duration"] > 0) {
		$WpD = $diff14days["count"]/((double)$diff14days["duration"]/(60*60*24));
	    } else {
		$WpD = 0.0;
	    }

	    if($diff14days["count"] >= 0) {
		$diff_14daysf = "+" . number_format($diff14days["count"], 0, $locale_info["decimal_point"], $locale_info["thousands_sep"]);
	    } else {
		$diff_14daysf = number_format($diff14days["count"], 0, $locale_info["decimal_point"], $locale_info["thousands_sep"]);
	    }
	    
	    $diff = number_format($stats->getDiffWUCount(), 0, $locale_info["decimal_point"], $locale_info["thousands_sep"]);
	    if($stats->getDiffWUCount() >= 0) {
		$diff = "+" . $diff;
	    }
	    $diff_members = number_format($stats->getDiffMemberCount(), 0, $locale_info["decimal_point"], $locale_info["thousands_sep"]);
	    if($stats->getDiffMemberCount() >= 0) {
		$diff_members = "+" . $diff_members;
	    }
	    
	    
	    
	    
	    $members_t    = trim($GLOBALS["team_members"]);
	    $results_t    = trim($GLOBALS["team_results"]);
	    $cpu_t        = trim($GLOBALS["team_cpu"]);
	    $average_t    = trim($GLOBALS["team_14days"]);
	    $width_t      = (max(strlen($members_t), strlen($results_t), strlen($cpu_t), strlen($average_t)) + 1) * imagefontwidth(2);
	    
	    $members_c    = number_format($stats->getMembers(), 0, $locale_info["decimal_point"],$locale_info["thousands_sep"]) . " (" . $diff_members . ") - " . number_format($stats->activeMembers, 0, $locale_info["decimal_point"],$locale_info["thousands_sep"]) . " " . $GLOBALS["team_active"];
	    $results_c    = number_format($stats->getWUCount(), 0, $locale_info["decimal_point"],$locale_info["thousands_sep"]) . " (" . $diff . ") WUs";
	    $cpu_c        = $cputimef . " (" . timetostr($stats->getAverageTime(), 14) . ")";
	    $average_c    = $diff_14daysf . " WUs (". number_format($WpD, 2, $locale_info["decimal_point"],$locale_info["thousands_sep"]) . " ".$GLOBALS["team_wu_day"].")";
	    $width_c      = max(strlen($members_c), strlen($results_c), strlen($cpu_c), strlen($average_c)) * imagefontwidth(2);
	    
	    
	    $width_min    = $width_t + $width_c + 16 + (2 * $this->tx);
	    
	    if($width_min < $this->width) {
		$width_t = $this->width - $width_c -16 - (2 * $this->tx);
	    } else {
		$this->width = $width_min;
	    }
	    $this->init();
	    $this->printBox();
	    
	    $charsPerLine3 = ($this->width - 2*$this->tx -16)/imagefontwidth(3);
	    $charsPerLine2 = ($this->width - 2*$this->tx -16)/imagefontwidth(2);
	    
	    $name = strtr($team->getName(), "", "23");
	    if (strlen($name) < $charsPerLine3) { # Name zentrieren
		$n = ($charsPerLine3 - strlen($name)) / 2;
		for ($i=1; $i<=$n; $i++) {
		    $name = " ".$name;
		}
	    } else {
		$name = substr($name, 0, $charsPerLine3);
	    }
	    
	    imagestring($this->im, 3, $this->tx, $this->ty,    $name, $this->text_color);
	    imagestring($this->im, 2, $this->tx, $this->ty+12, $members_t, $this->text_color);
	    imagestring($this->im, 2, $this->tx + $width_t, $this->ty+12, $members_c, $this->text_color);
	    
	    
	    imagestring($this->im, 2, $this->tx, $this->ty+24, $results_t, $this->text_color);
	    imagestring($this->im, 2, $this->tx + $width_t, $this->ty+24, $results_c, $this->text_color);
	    imagestring($this->im, 2, $this->tx + $width_t +1, $this->ty+24, number_format($stats->getWUCount(), 0, $locale_info["decimal_point"],$locale_info["thousands_sep"]), $this->text_color);
	    
	    imagestring($this->im, 2, $this->tx, $this->ty+36, $average_t, $this->text_color);
	    imagestring($this->im, 2, $this->tx + $width_t, $this->ty+36, $average_c, $this->text_color);
	    
	    imagestring($this->im, 2, $this->tx, $this->ty+48,$cpu_t, $this->text_color);
	    imagestring($this->im, 2, $this->tx + $width_t, $this->ty+48, $cpu_c, $this->text_color);
	    
	    
	    $this->sendGrafic();

	}
	
	
	
    }

?>