<?php

    require("php/basicuserstatslayout.php");

    Class UserstatsLayout extends BasicUserstatsLayout {
    
	# Dimensions of the counter
	var $width  = 241;
	var $height =  43;
	var $tx     =   4;
	var $ty     =   1;
	
	
	var $im, $white, $red, $gray, $lightgray, $lightblue, $text_color, $border_color, $background_color, $tcol, $bcol;
	
	function UserstatsLayout($userstats) {
	    $this->BasicUserstatsLayout($userstats);
	    $this->init();
	}
	
	
	
	function initColors() {
	    global $tcolor, $tc, $bcolor, $bc;
	    
	    if(isset($tcolor)) {
		$tc = $tcolor;
	    }
	    
	    if(isset($bcolor)) {
		$bc = $bcolor;
	    }
	    
	    $xml = $this->getProperties();
	    
	    if(!is_array($this->tcol)) {
		if (!isset($tc)) {
		    $found = $xml->search_attributes("properties:property","1:?","name","textcolor");
		    $tc = $xml->get_attribute("properties:property:defaultvalue", "1:" . $found[0] . ":1", "value");
		}
		$this->tcol = explode(",",$tc);
	    }
	    
	    if(!is_array($this->bcol)) {
		if (!isset($bc)) {
		    $found = $xml->search_attributes("properties:property","1:?","name","bordercolor");
		    $bc = $xml->get_attribute("properties:property:defaultvalue", "1:" . $found[0] . ":1", "value");
		}
		$this->bcol = explode(",",$bc);
	    }
	}
	
	
	function init() {
	    
	    
	    # initialize image pointer
	    $this->im = @imagecreate($this->width, $this->height);

	    # Farben definieren
	    $this->white = ImageColorAllocate($this->im, 255,255,255);
	    ImageColorTransparent($this->im, $this->white); # wei = transparent
	    
	    $this->red = ImageColorAllocate($this->im, 255,0,0);
	    $this->gray = ImageColorAllocate($this->im, 128,128,128);
	    $this->lightgray = ImageColorAllocate($this->im, 224,224,224);
	    $this->lightblue = ImageColorAllocate($this->im, 128,128,255);
	    
	    
	    $this->initColors();
	    $this->text_color = ImageColorAllocate($this->im, $this->tcol[0], $this->tcol[1], $this->tcol[2]);
	    $this->border_color = ImageColorAllocate($this->im, $this->bcol[0], $this->bcol[1], $this->bcol[2]);
	    
	    $this->background_color = $this->white;
	}
	
	
	/**
	 * returns the properties of this layout as a xml object
	 *
	 */
	function getProperties()
	{
	  if(!isset($this->xml)) {
	    
	    $myXML = BasicUserstatsLayout::getProperties();
	    
	    $i = 0;
	    
	    # Text color
	    $i++;
	    $myXML->create_tag("properties","1","property");
	    $myXML->set_attribute("properties:property", "1:$i", "name", "textcolor");
	    $myXML->set_attribute("properties:property", "1:$i", "alias", "tc");
	    $myXML->create_tag("properties:property","1:$i","type");
	    $myXML->set_attribute("properties:property:type","1:$i:1", "value", "rgb") ;
	    $myXML->create_tag("properties:property","1:$i","defaultvalue");
	    $myXML->set_attribute("properties:property:defaultvalue", "1:$i:1", "value", "0,0,0") ; // Standardwert
	    
	    # Border color
	    $i++;
	    $myXML->create_tag("properties","1","property");
	    $myXML->set_attribute("properties:property", "1:$i", "name", "bordercolor");
	    $myXML->set_attribute("properties:property", "1:$i", "alias", "bc");
	    $myXML->create_tag("properties:property","1:$i","type");
	    $myXML->set_attribute("properties:property:type","1:$i:1", "value", "rgb") ;
	    $myXML->create_tag("properties:property","1:$i","defaultvalue");
	    $myXML->set_attribute("properties:property:defaultvalue", "1:$i:1", "value", "0,0,0") ; // Standardwert
	    
#	    # Background color
#	    $i++;
#	    $myXML->create_tag("properties","1","property");
#	    $myXML->set_attribute("properties:property", "1:$i", "name", "bgcolor");
#	    $myXML->set_attribute("properties:property", "1:$i", "alias", "bg");
#	    $myXML->create_tag("properties:property","1:$i","type");
#	    $myXML->set_attribute("properties:property:type","1:$i:1", "value", "rgb") ;
#	    $myXML->set_attribute("properties:property:type","1:$i:1", "transparent", "true") ;
#	    $myXML->create_tag("properties:property","1:$i","defaultvalue");
#	    $myXML->set_attribute("properties:property:defaultvalue", "1:$i:1", "value", "255,255,255") ; // Standardwert
	    
	    
#	    # Label color
#	    $i++;
#	    $myXML->create_tag("properties","1","property");
#	    $myXML->set_attribute("properties:property", "1:$i", "name", "labelcolor");
#	    $myXML->set_attribute("properties:property", "1:$i", "alias", "lc");
#	    $myXML->create_tag("properties:property","1:$i","type");
#	    $myXML->set_attribute("properties:property:type","1:$i:1", "value", "rgb") ;
#	    $myXML->create_tag("properties:property","1:$i","defaultvalue");
#	    $myXML->set_attribute("properties:property:defaultvalue", "1:$i:1", "value", "128,128,255") ; // Standardwert

	    
	    # Language
	    $i++;
	    $myXML->create_tag("properties","1","property");
	    $myXML->set_attribute("properties:property", "1:$i", "name", "language");
	    $myXML->set_attribute("properties:property", "1:$i", "alias", "lng");
	    $myXML->create_tag("properties:property","1:$i","type");
	    $myXML->set_attribute("properties:property:type","1:$i:1", "value", "key_value") ;
	    
	    $keys   = "";
	    $values = "";
	    $current_locale = setlocale(LC_TIME, "0");
	    
	    $lang = explode(",", getenv("HTTP_ACCEPT_LANGUAGE"));
	    $lang_count = count($lang);
	    $lang_prio  = $lang_count + 1;
	    
	    $d = dir("language");
	    while($entry=$d->read())
	    {
		if(is_file("language/" . $entry))
		{
		    require("language/" . $entry);
		    $value = substr($entry, 0, strpos($entry, ".inc"));
		    $values .= ";" . $value;
		    $keys   .= ";" . $language_native . " / " . $language_international;
		    
		    $found = false;
		    
		    for($n = 0; ($n < $lang_count) && (!$found) && ($n < $lang_prio); $n++) {
			if(strpos($lang[$n], $value) !== false) {
			    $default = $value;
			    $lang_prio = $n;
			    $found = true;
			}
		    }
		}
	    }
	    
	    if(strlen($default) == 0) {
		$default = $GLOBALS["default_language"];
	    }
	    
	    setlocale(LC_TIME, $current_locale);
	    
	    $myXML->create_tag("properties:property","1:$i","defaultvalue");
	    $myXML->set_attribute("properties:property:defaultvalue", "1:$i:1", "value", $default) ; // Standardwert
	    
	    $myXML->create_tag("properties:property","1:$i","autodetect");
	    $myXML->set_attribute("properties:property:autodetect", "1:$i:1", "value", "true");
	    
	    $myXML->create_tag("properties:property","1:$i","keys");
	    $myXML->create_tag("properties:property","1:$i","values");
	    $myXML->set_attribute("properties:property:keys", "1:$i:1", "value", substr($keys, 1)) ; // Werte
	    $myXML->set_attribute("properties:property:values", "1:$i:1", "value", substr($values, 1)) ; // Schluessel
	    
	    # Image format
	    $i++;
	    $myXML->create_tag("properties","1","property");
	    $myXML->set_attribute("properties:property", "1:$i", "name", "graficsformat");
	    $myXML->set_attribute("properties:property", "1:$i", "alias", "gf");
	    $myXML->create_tag("properties:property","1:$i","type");
	    $myXML->set_attribute("properties:property:type","1:$i:1", "value", "key_value") ;
	    $myXML->create_tag("properties:property","1:$i","defaultvalue");
	    $myXML->set_attribute("properties:property:defaultvalue", "1:$i:1", "value", "png") ; // Standardwert

	    $knowntypes = imagetypes();
	    
	    $values = "";
	    $keys = "";
	    
	    if($knowntypes & IMG_PNG)
	    {
		    $values .= ";png";
		    $keys   .= ";Portable Network Grafics Format (PNG)";
		    if(strlen($default) == 0)
		    {
			$default = "png";
		    }
	    }
	    
	    if($knowntypes & IMG_JPG)
	    {
		    $values .= ";jpg;jpg75;jpg50;jpg25";
		    $keys   .= ";Jpeg Format (Quality: 100%);Jpeg Format (Quality: 75%);Jpeg Format (Quality: 50%);Jpeg Format (Quality: 25%)";
		    if(strlen($default) == 0)
		    {
			$default = "jpg";
		    }
	    }
	    
	    if($knowntypes & IMG_GIF)
	    {
		    $values .= ";gif";
		    $keys   .= ";Grafics Interchange Format (GIF)";
		    if(strlen($default) == 0)
		    {
			$default = "gif";
		    }
	    }
	    
	    if($knowntypes & IMG_WBMP)
	    {
		    $values .= ";wbmp";
		    $keys   .= ";WAP Bitmap Format (WBMP)";
		    if(strlen($default) == 0)
		    {
			$default = "wbmp";
		    }
	    }
		    
	    $myXML->create_tag("properties:property","1:$i","defaultvalue");
	    $myXML->set_attribute("properties:property:defaultvalue", "1:$i:1", "value", $default) ; // Standardwert
	    
	    $myXML->create_tag("properties:property","1:$i","keys");
	    $myXML->create_tag("properties:property","1:$i","values");
	    $myXML->set_attribute("properties:property:keys", "1:$i:1", "value", substr($keys, 1)) ; // Werte
	    $myXML->set_attribute("properties:property:values", "1:$i:1", "value", substr($values, 1)) ; // Schluessel
	    
	    
	    
	    
	    $this->xml = $myXML;
	  
	  } else {
	    $myXML = $this->xml;
	  }
	    
	    return $myXML;
	}
	

	function printBox()
        {
	    imagerectangle($this->im, 0, 0, $this->width -15, $this->height -1, $this->border_color);
	    imagerectangle($this->im, $this->width-1, 0, $this->width -15 , $this->height-1, $this->border_color);
	    imagestringup($this->im, 1,$this->width -12, $this->height -3, "ministat",$this->text_color);
	}
			    
			    

        function showError($headline, $msg, $status="")
	{
	    $this->printBox();
	
	    $charsPerLine = ($this->width -17)/imagefontwidth(2);
	
    	    # headline
	    imagestring($this->im, 3, $this->tx +1, 1, $headline, $this->gray );
	    imagestring($this->im, 3, $this->tx ,   0, $headline, $this->red );
	
	    #message
	    $msgwords = strtok($msg, " ");
	    $line = 1;
	    $text = "";
	    while($msgwords) {
		if((strlen($text) + strlen($msgwords)) > $charsPerLine) {
		    imagestring($this->im, 2, $this->tx , ($line * 12), $text, $this->text_color );
		    $line++;
		    $text = "";
		}
		$text .= $msgwords . " ";
		$msgwords = strtok(" ");
	    }
	    if(strlen(text) > 0) {
		imagestring($this->im, 2, $this->tx , ($line * 12), $text, $this->text_color );
	    }
	    imagestring($this->im, 2, $this->tx ,  48, $status, $this->text_color );
	
	    $this->error  = true;
	
	    $this->sendGrafic();
	}
	
	
	function sendGrafic()
	{
	    global $gf;
	    
	    $xml = $this->getProperties();
	    
	    if (!isset($gf)) {
		$found = $xml->search_attributes("properties:property","1:?","name","graficsformat");
		$gf = $xml->get_attribute("properties:property:defaultvalue", "1:" . $found[0] . ":1", "value");
	    }
	    
	    # Grafik ausgeben
	    if(substr($gf, 0, 3) == "jpg") {
		header('Content-type: image/jpeg');
		if($gf == "jpg")
		    imagejpeg($this->im);
		else if($gf == "jpg75")
		    imagejpeg($this->im, '', 75);
		else if($gf == "jpg50")
		    imagejpeg($this->im, '', 50);
		else if($gf == "jpg25")
		    imagejpeg($this->im, '', 25);
	    } else if($gf == "gif") {
		header('Content-type: image/gif');
		imagegif($this->im);
	    } else if($gf == "wbmp") {
		header('Content-type: image/vnd.wap.wbmp');
		imagewbmp($this->im);
	    } else {
		header('Content-type: image/png');
		imagepng($this->im);
	    }
	    
	}
	
	function showStats() {
	    
	
	    $this->printBox();
	    
	    $stats = $this->stats;
	    $user = $stats->getUser();
	    $im = $this->im;
	    
	    $diff14days = $stats->getDiff14days();
	    
	    if($diff14days["duration"] > 0) {
		$WpD = $diff14days["count"]/((double)$diff14days["duration"]/(60*60*24));
	    } else {
		$WpD = 0.0;
	    }
	    
	    setlocale(LC_ALL, $GLOBALS["language_locale"]);
	    $locale_info = localeconv();
	    
	    $name = $user->getName();
	    
	    $wu_t         = $GLOBALS["user_wus"] . ":";
	    $team_t       = trim($GLOBALS["user_team"]) . ":";
	    $width_t      = (max(strlen($wu_t), strlen($team_t)) + 2) * imagefontwidth(2);
	    
	
	    $wu_c = number_format($stats->getWUCount(), 0, $locale_info["decimal_point"], $locale_info["thousands_sep"]) . "  (" . number_format($WpD, 2, $locale_info["decimal_point"], $locale_info["thousands_sep"]) . " " . $GLOBALS["user_wu_day"] . ")";
	    
	    
	    $teamname = trim(strtr($user->getTeamname(), "", "23"));
	    
	    if(strlen($teamname) != 0) {
		$team_c = $teamname;
	    } else {
		$team_c = "-";
	    }
	    
	    
	    
	    $width_c      = max(strlen($wu_c), strlen($team_c)) * imagefontwidth(2);
	    
	    $width_min    = max(($width_t + $width_c), ($name * imagefontwidth(3))) + 16 + (2 * $this->tx);
	    $this->width = $width_min;
	    
#	    if($width_min < $this->width) {
#		$width_t = $this->width - $width_c -16 - (2 * $this->tx);
#	    } else {
#		$this->width = $width_min;
#	    }
	    $this->init();
	    $this->printBox();
	    
	    $charsPerLine3 = ($this->width - 2*$this->tx -16)/imagefontwidth(3);
	    $charsPerLine2 = ($this->width - 2*$this->tx -16)/imagefontwidth(2);
	    
	    
	    if (strlen($name) < $charsPerLine3) { # Name zentrieren
		$n = ($charsPerLine3 - strlen($name)) / 2;
		for ($i=1; $i<=$n; $i++) {
		    $name = " ".$name;
		}
	    }
	    
	    imagestring($this->im, 3, $this->tx, $this->ty,    $name, $this->text_color);
	    
	    imagestring($this->im, 2, $this->tx, $this->ty+12, $wu_t, $this->text_color);
	    imagestring($this->im, 2, $this->tx + $width_t, $this->ty+12, $wu_c, $this->text_color);
	    imagestring($this->im, 2, $this->tx + $width_t +1, $this->ty+12, number_format($stats->getWUCount(), 0, $locale_info["decimal_point"], $locale_info["thousands_sep"]), $this->text_color);
	    
	    imagestring($this->im, 2, $this->tx, $this->ty+24, $team_t, $this->text_color);
	    imagestring($this->im, 2, $this->tx + $width_t, $this->ty+24, $team_c, $this->text_color);
	    
	    $this->sendGrafic();

	}
	
	
	
    }

?>