<?php

    Class BasicTeamstatsLayout {
    
	# nothing for the user to change beyond this point!
	var $declareVersion_ = "";
	var $stats;
	
	function BasicTeamstatsLayout($teamstats) {
	    $this->stats = $teamstats;
	}
	
	
	function declareVersion($version = "") {
	    $this->declareVersion_ = $version;
	}
	
	
	/**
	 * returns the properties of this layout as a xml object
	 *
	 */
	function getProperties()
	{
	    require_once("php/kxparse.php");
	    $myXML = new KXParse("");
	    $myXML->set_CD(true);
	    $myXML->xml = "<properties></properties>";
	
	    return $myXML;    
	}
	

        function showError($headline, $msg, $status="")
	{
	    echo "<p><b>$headline</b><br/>$msg<br/>";
	    if($status != "") {
		echo "&nbsp;<br/><i><b>Status:</b> $status</i><br/>";
	    }
	    if($this->declareVersion_ != "") {
		echo "&nbsp;<br/><i><b>Version:</b> " . $this->declareVersion_ . "</i><br/>";
	    }
	    echo "</p>\n";
	}
	
	
	
	function showStats() {
	    
	    $stats = $this->stats;
	    $team = $stats->getTeam();
	    $im = $this->im;
	    
	    ## Daten formatieren und berechnen
	    $radiotime = ($stats->getWUCount() * 107)/60; # Radio Signal Time (1 Wu = 107s)
	    $radiotimef = timetostr($radiotime, 14);
	    $cputimef = timetostr($stats->getCputime(), 14);
	    
	    if($stats->getWUCount() != 0) {
		$averagef = timetostr($stats->getAveragetime(), 14);
	    } else {
		$averagef = timetostr(0, 14);
	    }

	    $reg_time = $team->getRegistrationTime();
	    $wu_per_day = $stats->getWUPerDay();

	    $teamname = $team->getTeamname();
	    
	    $name = $team->getName();

	    $diff14days = $stats->getDiff14days();
	    
	    
	    if($diff14days["duration"] > 0) {
		$WpD = $diff14days["count"]/((double)$diff14days["duration"]/(60*60*24));
	    } else {
		$WpD = 0.0;
	    }

	    if($diff14days["count"] >= 0) {
		$diff_14daysf = "+" . number_format($diff14days["count"], 0, ",", ".");
	    } else {
		$diff_14daysf = number_format($diff14days["count"], 0, ",", ".");
	    }
	    
	    
	    echo "<p>";
	    echo "<b>$name</b><br/>";
	    echo "<b>" . $GLOBALS["team_registered"] . "</b>" . strftime("%a, %x %H:%M:%S", $team->getRegistrationDate()) . "<br/>";
	    echo "<b>" . $GLOBALS["team_results"] . "</b>" . $stats->getWUCount() . " (" . $GLOBALS["team_rank"] . " " . $stats->getRank() . ", " . number_format($stats->getPercentage(), 2, ",", ".") . "%)<br/>";
	    echo "<b>" . $GLOBALS["team_cpu"] . "</b>" . $cputimef . " (" . $radiotimef . ")<br/>";
	    echo "<b>" . $GLOBALS["team_average"] . "</b>" . $averagef . " (". number_format($WpD, 2, ",", ".")." ".$GLOBALS["team_wu_day"].")<br/>";
	    echo "</p>\n";
	    
	}
	
	function show() {
	    if($this->stats->isValid()) {
		$this->showStats();
	    } else {
		if($this->stats->getStatus()==$this->stats->ERR_NO_TEAM){
		    # Fehler mit dem User
		    $team = $this->stats->getUser();
		    if($team->getStatus() == $team->ERR_SELECT_DATA) {
			$this->showError($GLOBALS["dberror"], $GLOBALS["team_err_readteam"], "MySQL: " . $team->mysql_errno);
		    } else if($team->getStatus() == $team->ERR_NO_TEAM) {
			$this->showError($GLOBALS["apperror"], sprintf($GLOBALS["team_err_id"], $team->getID()));
		    } else if($team->getStatus() == $team->ERR_NO_MAIL) {
			$this->showError($GLOBALS["apperror"], $GLOBALS["team_err_dontuseemail"]);
		    } else {
			$this->showError($GLOBALS["apperror"], "Unknown error occured", "Status: " . $team->getStatus() . ", " . $team->mysql_error);
		    }
		} else if($this->stats->getStatus()==$this->stats->ERR_UPDATE_TEAM){
		    # Fehler mit dem User
		    $team = $this->stats->getUser();
		    if($team->getStatus() == $team->ERR_UPDATE_DATA) {
			$this->showError($GLOBALS["dberror"], $GLOBALS["team_err_updateteam"], "MySQL: " . $team->mysql_errno);
		    } else {
			$this->showError($GLOBALS["dberror"], "Unknown error occured", "Status: " . $team->getStatus() . ", " . $team->mysql_error);
		    }
		} else {
		    # Fehler mit den Statistiken
		    $stats = $this->stats;
		    if($stats->getStatus() == $stats->ERR_READ_SERVER) {
			$this->showError($GLOBALS["servererror"], $GLOBALS["err_connectsrv"]);
		    } else if($stats->getStatus() == $stats->ERR_READ_DB_STATS) {
			$this->showError($GLOBALS["dberror"], $GLOBALS["err_readstats"], "MySQL: " . $stats->mysql_errno . " [" . $stats->errorline . "]");
		    } else if($stats->getStatus() == $stats->ERR_INSERT_STATS2) {
			$this->showError($GLOBALS["dberror"], $GLOBALS["err_updatestats"], "MySQL: " . $stats->mysql_errno . " [" . $stats->errorline . "]");
		    } else if($stats->getStatus() == $stats->ERR_NONEXISTING_TEAM) {
			$this->showError($GLOBALS["servererror"], $GLOBALS["team_err_unknownteam"]);
		    } else if($stats->getStatus() == $stats->ERR_SET_DB_LOCK) {
			$this->showError($GLOBALS["servererror"], $GLOBALS["err_get_db_lock"], "MySQL: " . $stats->mysql_errno . " [" . $stats->errorline . "]");
		    } else if($stats->getStatus() == $stats->ERR_REM_DB_LOCK) {
			$this->showError($GLOBALS["servererror"], $GLOBALS["err_rem_db_lock"], "MySQL: " . $stats->mysql_errno . " [" . $stats->errorline . "]");
		    } else if($stats->getStatus() == $stats->ERR_WRITE_DB_LOCK) {
			$this->showError($GLOBALS["servererror"], $GLOBALS["err_write_db_lock"], "MySQL: " . $stats->mysql_errno . " [" . $stats->errorline . "]");
		    } else if($stats->getStatus() == $stats->ERR_DELETE_DB_LOCK) {
			$this->showError($GLOBALS["servererror"], $GLOBALS["err_delete_db_lock"], "MySQL: " . $stats->mysql_errno . " [" . $stats->errorline . "]");
		    } else if($stats->getStatus() == $stats->ERR_READ_DB_LOCK) {
			$this->showError($GLOBALS["servererror"], $GLOBALS["err_read_db_lock"], "MySQL: " . $stats->mysql_errno . " [" . $stats->errorline . "]");
		    } else {
			$this->showError($GLOBALS["apperror"], "Unknown error occured", "Status: " . $stats->getStatus() . ", " . $stats->errorline);
		    }
		    
		}
	    }
	}
	
	
	
	
    }

?>