<?php


  if(!isset($GLOBALS["TEAMSTATS_LIB_"]))
  {
    $TEAMSTATS_LIB_ = 1;
    
    

    require_once("config.inc.php");
    require_once("./php/teamdata.class.php");
    
    class TeamStats {
    
	var $wu_count, $averagetime, $members, $activeMembers, $results, $timestamp;
	var $team;
	var $cachehit = false;
	var $cachedStats = 0;
	var $db_con;
	var $conn_id;
	var $status = 0;
	var $diffmembers, $diffwus;
	var $diffstats=false;
	
	var $version     = "v0.1.0";
	var $componentID = 2;
	
	var $lock_timestamp = 0;
	
	
	
	var $ERR_READ_SERVER   = 1;
	var $ERR_READ_DB_STATS = 2;
	var $ERR_READ_sdfs     = 3;
	var $ERR_INSERT_STATS1 = 4;
	var $ERR_INSERT_STATS2 = 5;
	var $ERR_NO_USER       = 7;
	var $ERR_NONEXISTING_TEAM = 8;
	var $ERR_UPDATE_TEAM   = 9;
	var $ERR_SET_DB_LOCK   = 10;
	var $ERR_REM_DB_LOCK   = 11;
	var $ERR_WRITE_DB_LOCK = 12;
	var $ERR_DELETE_DB_LOCK = 13;
	var $ERR_READ_DB_LOCK = 14;
	
	
	
	function calcDiffstats() {
	    if($this->diffstats==false) {
		## Bestimmung der maximalen Mitglieder und WUs vom Vortag
		$membersYesterday = 0;
		$wucountYesterday = $wu_count;
		$today        = mktime(0,0,0, date("m"), date("d"), date("Y"));
		$yesterday    = mktime(0,0,0, date("m"), date("d")-1, date("Y"));
		
		$team = $this->getTeam();
		$query = "SELECT MAX(members) AS maxmembers, MAX(wu_count) AS maxwucount FROM " . $GLOBALS["table_teamstats"] . " WHERE team_ID=" . $team->getID() . " AND timestamp>" . $yesterday . " AND timestamp<" . $today . "";
		$result = mysql_db_query($GLOBALS["db"], $query);
		if (!$result) {
		    $this->status = $this->ERR_READ_DB__STATS;
		    $this->mysql_errno = mysql_errno();
		    $this->mysql_error = mysql_error();
		    $this->errorline   = "calcDiffs()";
		    $this->diffwus = "N/A";
		    $this->diffmembers = "N/A";
		} else {
		    if(mysql_num_rows($result) != 0) {
			$row = mysql_fetch_row($result);
			$membersYesterday = $row[0];
			$wucountYesterday = $row[1];
		    }
		}

		if($wucountYesterday <= 0) {
		    $this->diffwus = 0;
		} else {
		    $this->diffwus = $this->wu_count - $wucountYesterday;
		}
		if($membersYesterday <= 0) {
		    $this->diffmembers = 0;
		} else {
		    $this->diffmembers = $this->members - $membersYesterday;
		}
		$this->diffstats = true;
	    }
	}
	

	function getDiffMemberCount() {
	    $this->calcDiffStats();
	    return $this->diffmembers;
	}
	
	function getDiffWUCount() {
	    $this->calcDiffStats();
	    return $this->diffwus;
	}
	
	
	function getCpuTime() {
	    return $this->wu_count * $this->averagetime;
	}
	
	function getWUCount() {
	    return $this->wu_count;
	}
	
	function getAverageTime() {
	    return $this->averagetime;
	}
	
	function getMembers() {
	    return $this->members;
	}
	
	function getActiveMembers() {
	    return $this->activeMembers;
	}
	
	function getResults() {
	    return $this->results;
	}
	
	function isValid() {
	    return ($this->status == 0);
	}
	
	function getStatus() {
	    return $this->status;
	}
	
	function getVersion() {
	    return $this->version;
	}
	
	function getComponentID() {
	    return $this->componentID;
	}
	
	function getTeam() {
	    return $this->team;
	}
	
	function insert()
        {
	
	    ## mal sehen, ob in den letzten 20 sek schon ein Eintrag existiert
	    $query = "SELECT ID FROM " . $GLOBALS["table_teamstats"] . " WHERE (team_ID=" . $this->team->getID() . ") AND (timestamp>=" . (time()-20) . ") LIMIT 0,1";
	    $result = mysql_db_query($GLOBALS["db"], $query);
	    if(!$result) {
		$this->status = $this->ERR_READ_DB_STATS;
		$this->mysql_errno = mysql_errno();
		$this->mysql_error = mysql_error();
		$this->errorline   = "Insert(1)";
		RETURN_FALSE;
	    } else {
		if(mysql_num_rows($result)>0) {
		    $row = mysql_fetch_row($result);
		    return $row[0];
		}
	    }

	    $query = "INSERT INTO " . $GLOBALS["table_teamstats"] . " (team_ID, wu_count, averagetime_x10, members, activeMembers, results, timestamp) VALUES(" . $this->team->getID() . ", " . $this->getWUCount() . ", " . ($this->getAveragetime() * 10) . ", " . $this->getMembers() . ", " . $this->getActiveMembers() . ", " . $this->getResults() . ", " . time() . ")";
	    # echo $query . "<br/>\n";
	    $result = mysql_db_query($GLOBALS["db"], $query);
	    if(!$result) {
		$this->status = $this->ERR_INSERT_STATS2;
		$this->mysql_errno = mysql_errno();
		$this->mysql_error = mysql_error();
		echo "Error:" . $this->mysql_error . "<br/>\n";
		$this->errorline   = "Insert(2)";
		return false;
	    } else {
		return mysql_insert_id();
	    }
	    
	    
	    $this->status = $this->ERR_INSERT_STATS2;
	    $this->mysql_errno = mysql_errno();
	    $this->mysql_error = mysql_error();
	    $this->errorline   = "Insert(3)";
	    RETURN_FALSE;
	}
	
	
	function fetchStatsFromCache() {
	    $query = "SELECT wu_count, averagetime_x10, members, activeMembers, results, timestamp  FROM " . $GLOBALS["table_teamstats"] . " WHERE team_ID=" . $this->team->getID() . " AND timestamp>=" . (time() - $GLOBALS["cachetime_team"]) . " LIMIT 0,1";
	    $result = mysql_db_query($GLOBALS["db"], $query);
	    if(!$result) {
		$this->status = $this->ERR_READ_DB_STATS;
		$this->mysql_errno = mysql_errno();
		$this->mysql_error = mysql_error();
		$this->errorline   = "Cache(1)";
	    } else {
		if(mysql_num_rows($result) != 0) {
		    ## team stats
		    $row = mysql_fetch_array($result);
		    $this->wu_count = $row["wu_count"];
		    $this->averagetime = $row["averagetime_x10"] / 10; # data is stored with a multiplikator of 10
		    $this->members = $row["members"];
		    $this->activeMembers = $row["activeMembers"];
		    $this->results = $row["results"];
		    $this->timestamp = $row["timestamp"];
		    $this->cachehit = true;
		    $this->cachedStats = 1;
		    return true;
		}
	    }
	    return false;
	}
	
	
	function fetchStatsFromServer() {
	    # close the db connection and free resources ...
	    # this is done because of the excessive load of the counter server
	    mysql_close($this->conn_id);
	
	    $team = $this->getteam();
	    $month = array("Jan" => "1", "Feb" => "2", "Mar" => "3", "Apr" => "4", "May" => "5", "Jun" => "6", "Jul" => "7", "Aug" => "8", "Sep" => "9", "Oct" => "10", "Nov" => "11", "Dec" => "12");
	    $activetime   = mktime(0,0,0, date("m"), (date("d")-$GLOBALS["activedays"]), date("Y"));
	    ## neue Daten von der Seti-Page saugen
	    $groupstats = @file("http://" . $GLOBALS["server1"] . "/fcgi-bin/fcgi?name=" . urlencode($team->getName()) . "&cmd=team_lookup_xml");
	    if (!$groupstats) {
	        ## Bei Fehler Server 2 benutzen
	        ## Nachteil: Wenn 2.Server ausfaellt gibt es evtl keine Fehlermeldung, sondern nur ein Timeout
		$groupstats = @file("http://" . $GLOBALS["server2"] . "/fcgi-bin/fcgi?name=" . urlencode($team->getName()) . "&cmd=team_lookup_xml");
	    }
	    
	    # reconnect to database
	    $this->conn_id = @mysql_connect($GLOBALS["db_server"],$GLOBALS["db_user"],$GLOBALS["db_password"]);
	    if (!$this->conn_id) {
		$this->status = $this->ERR_DB_CONNECT;
		$this->mysql_errno = mysql_errno();
		$this->mysql_error = mysql_error();
		$this->errorline   = "Server(4)";
		RETURN_FALSE;
	    }
	    
	    if (!$groupstats) { # Immer noch Fehler, dann Fehlerausgabe
		$this->status = $this->ERR_READ_SERVER;
		$this->errorline   = "Server(1)";
		return false;
	    } else {
	    
		
		## Daten auswerten
		$avg_hrs       = 0;
		$avg_min       = 0;
		$avg_sec       = 0;
		
		if(count($groupstats) < 5) {
		    $this->status = $this->ERR_NONEXISTING_TEAM;
		    $this->errorline   = "Server(3)";
		    return false;
		}
		$this->wu_count = 0;
		$this->results = 0;
		$this->activeMembers = 0;
		$this->members = 0;
		$this->averagetime = 0;
		
		$detectResults = true;
		$detectAveCPU = true;
		$detectLastResult = true;

		# This is a realy dirty parser, but it is faster than all the xml parsers that i have found
		for($i=0; $i < count($groupstats); $i++) {
		    if($isMemberTag) { 		   
			if(is_integer(strpos($groupstats[$i], "</member>"))) { 		       
			    # we are leaving a member tag
			    $isMemberTag = false; 		       
			    if($usernumresults != 0) {
				$this->wu_count += $usernumresults;
				## time must be multiplied with wu_count to weight them,
				## the result is the hole time for all the wu the member has calculated
				if(count($averagetime) == 6) {
				    # we have hours
				    $cpu_hrs += $averagetime[0] * $usernumresults;
				    $cpu_min += $averagetime[2] * $usernumresults;
				    $cpu_sec += $averagetime[4] * $usernumresults;
				} else {
				    # we have only minutes
				    $cpu_min += $averagetime[0] * $usernumresults;
				    $cpu_sec += $averagetime[2] * $usernumresults;
				}
				$usernumresults = 0;
			    }
			    $dateactive = 0;
			    if((count($datelastresult)-1) != 0) {
				# we have to cases for the format of the date
				if($datelastresult[2] > 0) {
				    # it is a day with two digits
				    $dateactive = mktime(23,59,59,$month[$datelastresult[1]], $datelastresult[2], $datelastresult[4]);
				} else {
				    # the day has one digit
				    $dateactive = mktime(23,59,59,$month[$datelastresult[1]], $datelastresult[3], $datelastresult[5]);
				}
			    }
			    if(($dateactive) - $activetime >= 0) {
				$this->activeMembers++;
			    }
			    $detectResults = true;
			    $detectAveCPU = true;
			    $detectLastResult = true;
			} else if($detectResults && is_integer(strpos($groupstats[$i], "<num"))) {
			    $detectResults = false;
			    $usernumresults = strip_tags($groupstats[$i]);
			} else if($detectAveCPU && is_integer(strpos($groupstats[$i], "<ave"))) {
			    $detectAveCPU = false;
			    $averagetime = explode(" ", strip_tags($groupstats[$i]));
			} else if($detectLastResult && is_integer(strpos($groupstats[$i], "<date"))) {
			    $detectLastResult = false;
			    $datelastresult = explode(" ", strip_tags($groupstats[$i]));
			}
		    } else if(!$isMemberTag && is_integer(strpos($groupstats[$i], "<member>"))) {
			# we enter a member tag
			$isMemberTag = true;
			$this->members++;
		    } else if(is_integer(strpos($groupstats[$i], "<numres"))) {
			$this->results = strip_tags($groupstats[$i]);
		    }
		}

		if($this->wu_count > 0) {
		    $this->averagetime = floor((((((double)$cpu_hrs/$this->wu_count)*60) + ((double)$cpu_min/$this->wu_count)) * 60) + (double)$cpu_sec/$this->wu_count);
		} else {
		    $this->averagetime = 0;
		}
		
		# store new retrieved statistics
		return $this->insert();
	    }
	    return false;
	}
	
	

	function TeamStats($id) {
	    $old_abort = ignore_user_abort(1);
	    $this->conn_id = @mysql_connect($GLOBALS["db_server"],$GLOBALS["db_user"],$GLOBALS["db_password"]);
	    if (!$this->conn_id) {
		$this->status = $this->ERR_DB_CONNECT;
		$this->mysql_errno = mysql_errno();
		$this->mysql_error = mysql_error();
		$this->errorline   = "init(1)";
	    } else {
		$this->team = new TeamData($id, $this->conn_id);
		
		if($this->team->isValid()) {
		    $readCache = false;
		    $readServer = false;
		    $lockingtries = 13;
		    while(!($readCache || $readServer ) && $this->isValid()) {
			$readCache = $this->fetchStatsFromCache();
			if($this->isValid() && (!$readCache)) {
			
			    ## check of database was not successful, no suitable data
			    ## the counter must fetch fresh data from Berkeley
			    
			    # lock the table, because we want to make shure, that only one client 
			    # fetches the data for one user at a time
			    $this->getTableLock();
			    
			    # lock if there is another thread fetching the data already
			    if($this->isValid() && $this->isEntryLocked()) {
				$this->releaseTableLock();
				sleep(1);
				# we must wait until the other thread is ready
				while(($this->isEntryLocked()) && ($lockingtries != 0)) {
				    $lockingtries--;
				    # close the db connection and free resources ...
				    # this is done because of the excessive load of the counter server
				    mysql_close($conn_id);
				    sleep(2);
				    $conn_id = @mysql_connect($GLOBALS["db_server"],$GLOBALS["db_user"],$GLOBALS["db_password"]);
				    if (!$conn_id) {
					$this->status = $this->ERR_DB_CONNECT;
					$this->mysql_errno = mysql_errno();
					$this->mysql_error = mysql_error();
					$this->errorline   = "init(2)";
					break;
				    }
				}
				# we don't want to rotate for ever ;)
				if($lockingtries == 0) {
				    $this->status = $this->ERR_READ_SERVER;
				    $this->errorline   = "init(3)";
				}
			    } else if($this->isValid()) {
				# we will fetch the data
				$readServer = true;
				$this->getEntryLock();
				$this->releaseTableLock();
				
				$this->fetchStatsFromServer();
				
				# $this->getTableLock();
				$this->releaseEntryLock();
				# $this->releaseTableLock();
			    } else {
				# in case of error release the lock on the table
				$this->releaseTableLock();
			    }
			}
		    }
		} else {
		    $this->status = $this->ERR_NO_TEAM;
		    $this->errorline   = "init(2)";
		}
	    }
	    $this->cleanupDB();
	    ignore_user_abort($old_abort);
	}
	
	
	#
	# Locking of the table $table_lock
	#
	function getTableLock()
	{
	    $ret_val = false;
	    $query = "LOCK TABLES " . $GLOBALS["table_lock"] . " WRITE";
	    $result = mysql_db_query($GLOBALS["db"], $query);
	    if(!$result) {
		$this->status = $this->ERR_SET_DB_LOCK;
		$this->mysql_errno = mysql_errno();
		$this->mysql_error = mysql_error();
		$this->errorline   = "GetTableLock()";
	    } else {
		$ret_val = true;
	    }
	    return $ret_val;
	}
	
	
	#
	# Lock a special user, so that another thread can't update the 
	# stats from the server
	# interprocess locking and syncronisation
	#
	function getEntryLock()
	{
	    $ret_val = false;
	    $team = $this->getTeam();
	    $this->lock_timestamp = time();
	    $query = "INSERT INTO " . $GLOBALS["table_lock"] . " (type, c_ID, timestamp) VALUES(" . $this->componentID . ", " . $team->getID() . ", " . $this->lock_timestamp . ")";
	    $result = mysql_db_query($GLOBALS["db"], $query);
	    if(!$result) {
		$this->status = $this->ERR_WRITE_DB_LOCK;
		$this->mysql_errno = mysql_errno();
		$this->mysql_error = mysql_error();
		$this->errorline   = "GetEntryLock()";
		$this->lock_timestamp = 0;
	    } else {
		$ret_val = true;
	    }
	    return $ret_val;
	}
	
	
	#
	# unlock the table $table_lock
	#
	function releaseTableLock()
	{
	    $ret_val = false;
	    $query = "UNLOCK TABLES";
	    $result = mysql_db_query($GLOBALS["db"], $query);
	    if(!$result) {
		$this->status = $this->ERR_REM_DB_LOCK;
		$this->mysql_errno = mysql_errno();
		$this->mysql_error = mysql_error();
		$this->errorline   = "ReleaseTableLock()";
	    } else {
		$ret_val = true;
	    }
	    return $ret_val;
	}
	
	
	#
	# remove the lock of the actual user id, so that other threads 
	# can try to reread the cache or update the stats
	# interprocess locking and syncronisation
	#
	function releaseEntryLock()
	{
	    $ret_val = false;
	    $team = $this->getTeam();
	    $query = "DELETE FROM " . $GLOBALS["table_lock"] . " WHERE type=" . $this->componentID . " AND c_ID=" . $team->getID() . " AND timestamp=" . $this->lock_timestamp;
	    $result = mysql_db_query($GLOBALS["db"], $query);
	    if(!$result) {
		$this->status = $this->ERR_DELETE_DB_LOCK;
		$this->mysql_errno = mysql_errno();
		$this->mysql_error = mysql_error();
		$this->errorline   = "ReleaseEntryLock()";
	    } else {
		$ret_val = true;
		$this->lock_timestamp = 0;
	    }
	    return $ret_val;
	}
	
	
	#
	# if there is a entry with the actual user id in the lock-table this function returns true
	# this function can be used to let the actual thread wait for "realeaseEntryLock() of 
	# another thread with the same user id
	# if the other lock is older than 180 seconds it is removed, because no PHP thread should run such long
	# interprocess locking and syncronisation
	#
	function isEntryLocked()
	{
	    $ret_val = false;
	    $team = $this->getTeam();
	    $query = "SELECT MAX(timestamp) FROM " . $GLOBALS["table_lock"] . " WHERE type=" . $this->componentID . " AND c_ID=" . $team->getID();
	    $result = mysql_db_query($GLOBALS["db"], $query);
	    if(!$result) {
		$this->status = $this->ERR_READ_DB_LOCK;
		$this->mysql_errno = mysql_errno();
		$this->mysql_error = mysql_error();
		$this->errorline   = "IsEntryLocked(1)";
	    } else {
		while($row = mysql_fetch_array($result)) {
		    if($row[0] > 0) {
			if($row[0] < (time() - 20)) {
			    # possible a dead lock
			    # we remove this to leave the counter alive
			    $query = "DELETE FROM " . $GLOBALS["table_lock"] . " WHERE type=" . $this->componentID . " AND c_ID=" . $team->getID();
			    $delete = mysql_db_query($GLOBALS["db"], $query);
			    if(!$result) {
				$this->status = $this->ERR_REM_DB_LOCK;
				$this->mysql_errno = mysql_errno();
				$this->mysql_error = mysql_error();
				$this->errorline   = "IsEntryLocked(2)";
			    }
			} else {
			    $ret_val = true;
			}
		    }
		}
	    }
	    return $ret_val;
	}


	function cleanupDB()
	{
	    ## alles lschen was lter als 16 Tage ist
	    $query = "DELETE FROM " . $GLOBALS["table_teamstats"] . " WHERE timestamp<" . (time()-1382400);
	    $result = mysql_db_query($GLOBALS["db"], $query);
	    if(!$result) {
	    } else {
	        return true;
	    }
	    return false;
	}
	
	
	function getDiff14days() {
	    $lasttwoweeks = mktime(0,0,0, date("m"), date("d")-14, date("Y"));
	    $retval = array();
	    $retval["count"] = 0;
	    $retval["duration"] = time() - $lasttwoweeks;
	    $team=$this->getTeam();
	    

	    $query = "SELECT wu_count, timestamp FROM " . $GLOBALS["table_teamstats"] . " WHERE team_ID=" . $team->getID() . " AND timestamp>=" . ($lasttwoweeks) . " ORDER BY timestamp LIMIT 0,1";
	    $result = mysql_db_query($GLOBALS["db"], $query);
	    if(!$result) {
		$this->status = $this->ERR_READ_DB_STATS;
		$this->mysql_errno = mysql_errno();
		$this->mysql_error = mysql_error();
		$this->errorline   = "14days(1)";
	    } else {
		if(mysql_num_rows($result)>0) {
		    $row = mysql_fetch_row($result);
		    $retval["count"] = $this->getWUCount() - $row[0];
		    $retval["duration"] = time() - $row[1];
		}
	    }
	    return $retval;
	}
	
	
	function getLockTimestamp() {
	    return $this->lock_timestamp;
	}
    
    
    }
    
  }
    
?>