<?php

    $startTime = time();
    $version = "v 3.4.1";



    function existsLayout($layout) {
	return file_exists("layout/user/" . $layout . ".php");
    }
    
    function save_shutdown() {
	if(isset($GLOBALS["stats"])) {
	    $stats = $GLOBALS["stats"];
	    if($stats->getLockTimestamp() != 0) {
		# this should savely remove the locks in the interthread sync
		# $stats->getTableLock();
		$stats->releaseEntryLock();
		# $stats->releaseTableLock();
	    }
	}
    }


    require("config.inc.php");
    require("php/userstats.class.php");
    require("php/functions.lib.php");
    
    
    if (!isset($l) || ($l == "") || !existsLayout($l)) {
	$l = 1;
    }
    require("layout/user/" . $l . ".php");
    
    # for compatibility
    if (isset($email) && (strlen($email) != 0)) {
	$id = $email;
    }
    
    if (!isset($id) || ($id == "")) {
	$id = 1;
    }
    
    register_shutdown_function(save_shutdown());
    
    $stats = new UserStats($id);
    
    $counter = new UserstatsLayout($stats);
    
    # Wenn keine Sprache angegeben dann Default des Layouts oder aus den Config nutzen
    if (!isset($lng) || ($lng == "")) {
	$xml = $counter->getProperties();
	$found = $xml->search_attributes("properties:property","1:?","name","language");
	if(is_array($found) && (count($found) > 0)) {
	    $lng = $xml->get_attribute("properties:property:defaultvalue", "1:" . $found[0] . ":1", "value");
	} else {
	    $lng = $GLOBALS["default_language"];
	}
    }
    require("language/" . $lng . ".inc");
    
    $counter->declareVersion($version);
    $counter->show();
    
    
    ## Statistik
    ## entryID <= 0 zeigt Fehler an ...
    
    $user = $stats->getUser();
    $entryID = $user->getID();
    if(!$stats->isValid()) {
	$entryID *= -1;
    }
    
    storeHit($stats->getComponentID() , $entryID, $stats->cachedStats , time() - $startTime );
?>